<?php

namespace App\Http\Requests\Admin;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class ProductRequest extends FormRequest
{

    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin', 'sub_admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule('products'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'image'=>'required',
            'date'=>'required|date',
            'hours'=>'required|numeric|min:1',
            'publish'=>'required|in:true,false',
            'category_id'=>'required|exists:categories,id',
            'city_id'=>'required|exists:cities,id'
        ];

        foreach (languages() as $lang) {
            $lang_rules=[
                'name_'.$lang->local=> 'required|max:25',
                'description_'.$lang->local=> 'required',
                // 'details_'.$lang->local=> 'required',
            ];
            $rules= array_merge($rules, $lang_rules);
        }
        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $field = metaFields('products');
        $attributes=[
            'image' => __('products.image'),
            'category_id' => __('products.category_id'),
            'city_id' => __('products.city_id'),
            'date' => __('products.date'),
            'hours' => __('products.hours'),
            'publish' => __('products.publish'),

        ];

        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local=>  __('products.name') .' '.$lang->local,
                'description_'.$lang->local=>  __('products.description') .' '.$lang->local,
                'details_'.$lang->local=>  __('products.details') .' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests

        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
